// $Id: padma.js,v 1.3 2005/04/18 19:19:55 vnagarjuna Exp $ -->

/* ***** BEGIN LICENSE BLOCK ***** 
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Initial Developer of the Original Code is Nagarjuna Venna.
 * Portions created by the Initial Developer are Copyright (C) 2005
 * by the Initial Developer. All Rights Reserved.
 *
 * Contributor(s): Nagarjuna Venna <vnagarjuna@yahoo.com>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

//Unicode
function Unicode() 
{
}

//Various Signs
Unicode.candrabindu = "\u0C01";
Unicode.anusvara    = "\u0C02";  //sunna
Unicode.visarga     = "\u0C03";

//Independent Vowels
Unicode.letter_A    = "\u0C05";
Unicode.letter_AA   = "\u0C06";
Unicode.letter_I    = "\u0C07";
Unicode.letter_II   = "\u0C08";
Unicode.letter_U    = "\u0C09";
Unicode.letter_UU   = "\u0C0A";
Unicode.letter_R    = "\u0C0B";   //vocalic R
Unicode.letter_RR   = "\u0C60";   //vocalic R
Unicode.letter_L    = "\u0C0C";   //vocalic L
Unicode.letter_LL   = "\u0C61";   //vocalic L
Unicode.letter_E    = "\u0C0E";
Unicode.letter_EE   = "\u0C0F";
Unicode.letter_AI   = "\u0C10";
Unicode.letter_O    = "\u0C12";
Unicode.letter_OO   = "\u0C13";
Unicode.letter_AU   = "\u0C14";

//Consonants
Unicode.letter_KA   = "\u0C15";
Unicode.letter_KHA  = "\u0C16";
Unicode.letter_GA   = "\u0C17";
Unicode.letter_GHA  = "\u0C18";
Unicode.letter_NGA  = "\u0C19";
Unicode.letter_CA   = "\u0C1A";
Unicode.letter_CHA  = "\u0C1B";
Unicode.letter_JA   = "\u0C1C";
Unicode.letter_JHA  = "\u0C1D";
Unicode.letter_NYA  = "\u0C1E";
Unicode.letter_TTA  = "\u0C1F";
Unicode.letter_TTHA = "\u0C20";
Unicode.letter_DDA  = "\u0C21";
Unicode.letter_DDHA = "\u0C22";
Unicode.letter_NNA  = "\u0C23";
Unicode.letter_TA   = "\u0C24";
Unicode.letter_THA  = "\u0C25";
Unicode.letter_DA   = "\u0C26";
Unicode.letter_DHA  = "\u0C27";
Unicode.letter_NA   = "\u0C28";
Unicode.letter_PA   = "\u0C2A";
Unicode.letter_PHA  = "\u0C2B";
Unicode.letter_BA   = "\u0C2C";
Unicode.letter_BHA  = "\u0C2D";
Unicode.letter_MA   = "\u0C2E";
Unicode.letter_YA   = "\u0C2F";
Unicode.letter_RA   = "\u0C30";
Unicode.letter_RRA  = "\u0C31";
Unicode.letter_LA   = "\u0C32";
Unicode.letter_LLA  = "\u0C33";
Unicode.letter_VA   = "\u0C35";
Unicode.letter_SHA  = "\u0C36";
Unicode.letter_SSA  = "\u0C37";
Unicode.letter_SA   = "\u0C38";
Unicode.letter_HA   = "\u0C39";

//Dependent Vowel Signs
Unicode.vowelsn_AA  = "\u0C3E";
Unicode.vowelsn_I   = "\u0C3F";
Unicode.vowelsn_II  = "\u0C40";
Unicode.vowelsn_U   = "\u0C41";
Unicode.vowelsn_UU  = "\u0C42";
Unicode.vowelsn_R   = "\u0C43";
Unicode.vowelsn_RR  = "\u0C44";
Unicode.vowelsn_E   = "\u0C46";
Unicode.vowelsn_EE  = "\u0C47";
Unicode.vowelsn_AI  = "\u0C48";   //this is the same as 0C46 followed by 0C56
Unicode.vowelsn_O   = "\u0C4A";
Unicode.vowelsn_OO  = "\u0C4B";
Unicode.vowelsn_AU  = "\u0C4C";

//Miscellaneous Signs
Unicode.misc_VIRAMA   = "\u0C4D";   //halant
Unicode.misc_LENGTH   = "\u0C55";
Unicode.misc_AILEN    = "\u0C56";
Unicode.misc_AVAGRAHA = "\u093D";
Unicode.misc_NUKTA    = "\u093C";
Unicode.misc_UDATTA   = "\u0951";
Unicode.misc_ANUDATTA = "\u0952";
Unicode.misc_SVARITA  = "\u0951";
Unicode.misc_DANDA    = "\u0964";
Unicode.misc_DDANDA   = "\u0965";

//Ligatures
Unicode.ligature_KSH = "\u0C15\u0C4D\u0C37";
//nukt
Unicode.nukt_TCH     = "\u0C1A\u093C\u0C4D";
Unicode.nukt_TJ      = "\u0C1C\u093C\u0C4D";
//Miscellaneous
Unicode.conjuct_JNY  = "\u0C1C\u0C4D\u0C1E";
Unicode.conjuct_DDDD = "\u0C21\u0C4D\u0C21";
Unicode.conjuct_TTTT = "\u0C1F\u0C$D\u0C1F";

//Digits
Unicode.digit_ZERO  = "\u0C66";
Unicode.digit_ONE   = "\u0C67";
Unicode.digit_TWO   = "\u0C68";
Unicode.digit_THREE = "\u0C69";
Unicode.digit_FOUR  = "\u0C6A";
Unicode.digit_FIVE  = "\u0C6B";
Unicode.digit_SIX   = "\u0C6C";
Unicode.digit_SEVEN = "\u0C6D";
Unicode.digit_EIGHT = "\u0C6E";
Unicode.digit_NINE  = "\u0C6F";

//Zero-Width Joiner/Non Joiner for Virama
Unicode.misc_ZWNJ   = "\u200C";
Unicode.misc_ZWJ    = "\u200D";

Unicode.independentVowels = new Array();
Unicode.vowelMap = new Array();

Unicode.independentVowels[Unicode.letter_A] = true;
Unicode.independentVowels[Unicode.letter_AA] = true;
Unicode.independentVowels[Unicode.letter_I] = true;
Unicode.independentVowels[Unicode.letter_II] = true;
Unicode.independentVowels[Unicode.letter_U] = true;
Unicode.independentVowels[Unicode.letter_UU] = true;
Unicode.independentVowels[Unicode.letter_R] = true;
Unicode.independentVowels[Unicode.letter_RR] = true;
Unicode.independentVowels[Unicode.letter_L] = true;
Unicode.independentVowels[Unicode.letter_LL] = true;
Unicode.independentVowels[Unicode.letter_E] = true;
Unicode.independentVowels[Unicode.letter_EE] = true;
Unicode.independentVowels[Unicode.letter_AI] = true;
Unicode.independentVowels[Unicode.letter_O] = true;
Unicode.independentVowels[Unicode.letter_OO] = true;
Unicode.independentVowels[Unicode.letter_AU] = true;

Unicode.vowelMap[Unicode.letter_AA] = Unicode.vowelsn_AA;
Unicode.vowelMap[Unicode.letter_I] = Unicode.vowelsn_I;
Unicode.vowelMap[Unicode.letter_II] = Unicode.vowelsn_II;
Unicode.vowelMap[Unicode.letter_U] = Unicode.vowelsn_U;
Unicode.vowelMap[Unicode.letter_UU] = Unicode.vowelsn_UU;
Unicode.vowelMap[Unicode.letter_R] = Unicode.vowelsn_R;
Unicode.vowelMap[Unicode.letter_RR] = Unicode.vowelsn_RR;
Unicode.vowelMap[Unicode.letter_E] = Unicode.vowelsn_E;
Unicode.vowelMap[Unicode.letter_EE] = Unicode.vowelsn_EE;
Unicode.vowelMap[Unicode.letter_AI] = Unicode.vowelsn_AI;
Unicode.vowelMap[Unicode.letter_O] = Unicode.vowelsn_O;
Unicode.vowelMap[Unicode.letter_OO] = Unicode.vowelsn_OO;
Unicode.vowelMap[Unicode.letter_AU] = Unicode.vowelsn_AU;

Unicode.isInherentVowel = function (str) 
{
    return str == Unicode.letter_A;
}
	
Unicode.isVirama = function (str) 
{
    return str == Unicode.misc_VIRAMA;
}
	
Unicode.getDependentVowel = function (str) 
{
    return Unicode.vowelMap[str];
}

//Unsupported transfromations are just commented out
Unicode.fromPadma = new Array();

Unicode.fromPadma[Padma.candrabindu] = Unicode.candrabindu;
Unicode.fromPadma[Padma.visarga]     = Unicode.visarga;
Unicode.fromPadma[Padma.pollu]       = Unicode.misc_VIRAMA + Unicode.misc_ZWNJ;
Unicode.fromPadma[Padma.anusvara]    = Unicode.anusvara;
Unicode.fromPadma[Padma.avagraha]    = Unicode.misc_AVAGRAHA;
//Unicode.fromPadma[Padma.yati]      = Unicode.misc_YATI;
Unicode.fromPadma[Padma.udAtta]      = Unicode.misc_UDATTA;
Unicode.fromPadma[Padma.anudAtta]    = Unicode.misc_ANUDATTA;
Unicode.fromPadma[Padma.svarita]     = Unicode.misc_SVARITA;
//Unicode.fromPadma[Padma.guru]      = Unicode.misc_GURU;
//Unicode.fromPadma[Padma.laghu]     = Unicode.misc_LAGHU;
Unicode.fromPadma[Padma.danda]       = Unicode.misc_DANDA;
Unicode.fromPadma[Padma.ddanda]      = Unicode.misc_DDANDA;

//digits
Unicode.fromPadma[Padma.digit_ZERO]  = Unicode.digit_ZERO;
Unicode.fromPadma[Padma.digit_ONE]   = Unicode.digit_ONE;
Unicode.fromPadma[Padma.digit_TWO]   = Unicode.digit_TWO;
Unicode.fromPadma[Padma.digit_THREE] = Unicode.digit_THREE;
Unicode.fromPadma[Padma.digit_FOUR]  = Unicode.digit_FOUR;
Unicode.fromPadma[Padma.digit_FIVE]  = Unicode.digit_FIVE;
Unicode.fromPadma[Padma.digit_SIX]   = Unicode.digit_SIX;
Unicode.fromPadma[Padma.digit_SEVEN] = Unicode.digit_SEVEN;
Unicode.fromPadma[Padma.digit_EIGHT] = Unicode.digit_EIGHT;
Unicode.fromPadma[Padma.digit_NINE]  = Unicode.digit_NINE;

//Vowels
Unicode.fromPadma[Padma.vowel_A]     = Unicode.letter_A;
Unicode.fromPadma[Padma.vowel_AA]    = Unicode.letter_AA;
Unicode.fromPadma[Padma.vowel_I]     = Unicode.letter_I;
Unicode.fromPadma[Padma.vowel_II]    = Unicode.letter_II;
Unicode.fromPadma[Padma.vowel_U]     = Unicode.letter_U;
Unicode.fromPadma[Padma.vowel_UU]    = Unicode.letter_UU;
Unicode.fromPadma[Padma.vowel_R]     = Unicode.letter_R;
Unicode.fromPadma[Padma.vowel_RR]    = Unicode.letter_RR;
Unicode.fromPadma[Padma.vowel_L]     = Unicode.letter_L;
Unicode.fromPadma[Padma.vowel_LL]    = Unicode.letter_LL;
Unicode.fromPadma[Padma.vowel_E]     = Unicode.letter_E;
Unicode.fromPadma[Padma.vowel_EE]    = Unicode.letter_EE;
Unicode.fromPadma[Padma.vowel_AI]    = Unicode.letter_AI;
Unicode.fromPadma[Padma.vowel_O]     = Unicode.letter_O;
Unicode.fromPadma[Padma.vowel_OO]    = Unicode.letter_OO;
Unicode.fromPadma[Padma.vowel_AU]    = Unicode.letter_AU;

//Consonants
Unicode.fromPadma[Padma.consnt_KA]   = Unicode.letter_KA;
Unicode.fromPadma[Padma.consnt_KHA]  = Unicode.letter_KHA;
Unicode.fromPadma[Padma.consnt_GA]   = Unicode.letter_GA;
Unicode.fromPadma[Padma.consnt_GHA]  = Unicode.letter_GHA;
Unicode.fromPadma[Padma.consnt_NGA]  = Unicode.letter_NGA;
Unicode.fromPadma[Padma.consnt_CA]   = Unicode.letter_CA;
Unicode.fromPadma[Padma.consnt_CHA]  = Unicode.letter_CHA;
Unicode.fromPadma[Padma.consnt_JA]   = Unicode.letter_JA;
Unicode.fromPadma[Padma.consnt_JHA]  = Unicode.letter_JHA;
Unicode.fromPadma[Padma.consnt_NYA]  = Unicode.letter_NYA;
Unicode.fromPadma[Padma.consnt_TTA]  = Unicode.letter_TTA;
Unicode.fromPadma[Padma.consnt_TTHA] = Unicode.letter_TTHA;
Unicode.fromPadma[Padma.consnt_DDA]  = Unicode.letter_DDA;
Unicode.fromPadma[Padma.consnt_DDHA] = Unicode.letter_DDHA;
Unicode.fromPadma[Padma.consnt_NNA]  = Unicode.letter_NNA;
Unicode.fromPadma[Padma.consnt_TA]   = Unicode.letter_TA;
Unicode.fromPadma[Padma.consnt_THA]  = Unicode.letter_THA;
Unicode.fromPadma[Padma.consnt_DA]   = Unicode.letter_DA;
Unicode.fromPadma[Padma.consnt_DHA]  = Unicode.letter_DHA;
Unicode.fromPadma[Padma.consnt_NA]   = Unicode.letter_NA;
Unicode.fromPadma[Padma.consnt_PA]   = Unicode.letter_PA;
Unicode.fromPadma[Padma.consnt_PHA]  = Unicode.letter_PHA;
Unicode.fromPadma[Padma.consnt_BA]   = Unicode.letter_BA;
Unicode.fromPadma[Padma.consnt_BHA]  = Unicode.letter_BHA;
Unicode.fromPadma[Padma.consnt_MA]   = Unicode.letter_MA;
Unicode.fromPadma[Padma.consnt_YA]   = Unicode.letter_YA;
Unicode.fromPadma[Padma.consnt_RA]   = Unicode.letter_RA;
Unicode.fromPadma[Padma.consnt_LA]   = Unicode.letter_LA;
Unicode.fromPadma[Padma.consnt_VA]   = Unicode.letter_VA;
Unicode.fromPadma[Padma.consnt_SHA]  = Unicode.letter_SHA;
Unicode.fromPadma[Padma.consnt_SSA]  = Unicode.letter_SSA;
Unicode.fromPadma[Padma.consnt_SA]   = Unicode.letter_SA;
Unicode.fromPadma[Padma.consnt_HA]   = Unicode.letter_HA;
Unicode.fromPadma[Padma.consnt_LLA]  = Unicode.letter_LLA;
Unicode.fromPadma[Padma.consnt_KSH]  = Unicode.ligature_KSH;
Unicode.fromPadma[Padma.consnt_RRA]  = Unicode.letter_RRA;

//extinct consonants
Unicode.fromPadma[Padma.consnt_TCH]  = Unicode.nukt_TCH;
Unicode.fromPadma[Padma.consnt_TJ]   = Unicode.nukt_TJ;

//Gunimtaalu
Unicode.fromPadma[Padma.vowelsn_AA]  = Unicode.vowelsn_AA;
Unicode.fromPadma[Padma.vowelsn_I]   = Unicode.vowelsn_I;
Unicode.fromPadma[Padma.vowelsn_II]  = Unicode.vowelsn_II;
Unicode.fromPadma[Padma.vowelsn_U]   = Unicode.vowelsn_U;
Unicode.fromPadma[Padma.vowelsn_UU]  = Unicode.vowelsn_UU;
Unicode.fromPadma[Padma.vowelsn_R]   = Unicode.vowelsn_R;
Unicode.fromPadma[Padma.vowelsn_RR]  = Unicode.vowelsn_RR;
//Unicode.fromPadma[Padma.vowelsn_L]   = Unicode.vowelsn_L;
//Unicode.fromPadma[Padma.vowelsn_LL]  = Unicode.vowelsn_LL;
Unicode.fromPadma[Padma.vowelsn_E]   = Unicode.vowelsn_E;
Unicode.fromPadma[Padma.vowelsn_EE]  = Unicode.vowelsn_EE;
Unicode.fromPadma[Padma.vowelsn_AI]  = Unicode.vowelsn_AI;
Unicode.fromPadma[Padma.vowelsn_O]   = Unicode.vowelsn_O;
Unicode.fromPadma[Padma.vowelsn_OO]  = Unicode.vowelsn_OO;
Unicode.fromPadma[Padma.vowelsn_AU]  = Unicode.vowelsn_AU;
Unicode.fromPadma[Padma.vowelsn_AILEN]  = Unicode.misc_AILEN;

Unicode.transformFromPadma = function (str)
{
    var ret = Unicode.fromPadma[str];
    if (ret == null) {
        var code = str.charCodeAt(0);
        if (code >= 0x80) {
            var old = Unicode.fromPadma[String.fromCharCode(code - 0x80)];
            if (old != null)
                return Unicode.misc_VIRAMA + old;
        }
        return str;
    }
    return ret;
}
